/*
 * =====================================================================================
 * 
 *     Modulename:
 *       Filename:  maibu_window_sdk.h
 *
 *    Description:  
 *    Corporation:
 * 
 *         Author:  gliu (), gliu@damaijiankang.com
 *        Created:  20141110 17ʱ4929
 *
 * =====================================================================================
 */

#ifndef _DAMAI_WINDOW_SDK_H
#define _DAMAI_WINDOW_SDK_H


#include <stdint.h>
#include "maibu_layer_sdk.h"


typedef void(* ClickCallback)( void *context);


/**/
enum ButtonId
{
	ButtonIdBack,	//
	ButtonIdUp,	//
	ButtonIdSelect,	//ѡ
	ButtonIdDown	//
};



/**/
enum AnimationType
{
	AnimationTypeNormal,	//޶
	AnimationTypeSlipBottom,//ӵײϻ
	AnimationTypeSlipRight	//ұ󻬶
};

#if defined (__CC_ARM)
#pragma push
#pragma pack(1)
#else 
#pragma pack(push, 1)
#endif


/*ṹ*/
typedef struct tag_Click
{
	enum ButtonId id;	//
	ClickCallback callback;	//Ӧİص
}Click, *P_Click;



typedef struct tag_Rubbish
{
	uint8_t y1;
	uint8_t y2;
}Rubbish, *P_Rubbish;


/*ڽṹ*/
typedef struct tag_Window
{
	uint32_t app_id;	
	uint8_t top_row;	
	uint8_t max_row;	
	int8_t index:4;		
	uint8_t update:4;	
	uint8_t bar_h;		
	uint8_t title_h;	
	enum GColor bg_color;	
	enum AnimationType animation;	
	uint8_t selected_layer:6;	
	uint8_t num_layers:6;	
	uint8_t num_clicks:4;	
	uint8_t timer_id;	
	P_Layer *layers;	
	Click *clicks;	
	Rubbish rubbish;	
		

}Window, *P_Window;

#if defined (__CC_ARM)
#pragma pop
#else
#pragma pack(pop)
#endif


/*
 *--------------------------------------------------------------------------------------
 *     function:  app_window_set_bg_color
 *    parameter: 
 *       return:
 *  description:  ôڱɫ
 * 	  other:
 *--------------------------------------------------------------------------------------
 */
extern void app_window_set_bg_color(P_Window p_window, enum GColor color);



/*
 *--------------------------------------------------------------------------------------
 *     function:  app_window_get_layer_by_id
 *    parameter: 
 *       return:
 *  description:  layer idȡĳͼ
 * 	  other:
 *--------------------------------------------------------------------------------------
 */
 extern P_Layer app_window_get_layer_by_id(P_Window p_window, int8_t id);



/*
 *--------------------------------------------------------------------------------------
 *     function:  app_window_get_index
 *    parameter: 
 *       return:
 *  description:  ȡк 
 * 	  other:
 *--------------------------------------------------------------------------------------
 */
 extern int8_t app_window_get_index(P_Window p_window);



/*
 *--------------------------------------------------------------------------------------
 *     function:  app_window_replace_layer
 *    parameter: 
 *       return:
 *  description:  滻ͼ 
 * 	  other:
 *--------------------------------------------------------------------------------------
 */
 extern void app_window_replace_layer(P_Window p_window, P_Layer old_p_layer, P_Layer new_p_layer);



/*
 *--------------------------------------------------------------------------------------
 *     function:  app_window_disable_layer
 *    parameter: 
 *       return:
 *  description:  ôĳͼ㲻
 * 	  other:
 *--------------------------------------------------------------------------------------
 */
 extern  void app_window_disable_layer(P_Window p_window, P_Layer p_layer);





/*
 *--------------------------------------------------------------------------------------
 *     function:  app_window_add_layer
 *    parameter:  window   layer Ҫӵͼ
 *       return:
 *  description:  ͼ㵽 
 * 	  other:
 *--------------------------------------------------------------------------------------
 */
 extern int8_t app_window_add_layer(Window *window, Layer *layer);




/*
 *--------------------------------------------------------------------------------------
 *     function:  app_window_create
 *    parameter: 
 *       return:
 *  description:   
 * 	  other:
 *--------------------------------------------------------------------------------------
 */
 extern Window *app_window_create(void);



/*
 *--------------------------------------------------------------------------------------
 *     function:  app_window_destroy
 *    parameter: 
 *       return:
 *  description:  ٴ 
 * 	  other:
 *--------------------------------------------------------------------------------------
 */
 extern void app_window_destroy(Window *window);



/*
 *--------------------------------------------------------------------------------------
 *     function:  app_window_click_subscribe
 *    parameter:  window ¼ button_id   click_callback ص 
 *       return:
 *  description:  עᰴĻص¼ 
 * 	  other:
 *--------------------------------------------------------------------------------------
 */
 extern void app_window_click_subscribe(Window *window, enum ButtonId button_id, ClickCallback click_callback);




/*
 *--------------------------------------------------------------------------------------
 *     function:  app_window_set_up_button
 *    parameter: 
 *       return:
 *  description:  ϰ,Ҫѡͼʱʹ
 * 	  other:
 *--------------------------------------------------------------------------------------
 */
 extern void app_window_set_up_button(P_Window p_window);



/*
 *--------------------------------------------------------------------------------------
 *     function:  app_window_set_down_button
 *    parameter: 
 *       return:
 *  description:  °, Ҫѡͼʱʹ
 * 	  other:
 *--------------------------------------------------------------------------------------
 */
 extern void app_window_set_down_button(P_Window p_window);



/*
 *--------------------------------------------------------------------------------------
 *     function:  window_set_current_selected_layer
 *    parameter: 
 *       return:
 *  description:  õǰѡͼ
 * 	  other:
 *--------------------------------------------------------------------------------------
 */
 extern void app_window_set_current_selected_layer(P_Window p_window, uint8_t index);


/*
 *--------------------------------------------------------------------------------------
 *     function:  ôڱ߶
 *    parameter: 
 *       return:
 *  description:  
 * 	  other:
 *--------------------------------------------------------------------------------------
 */
extern void app_window_set_title_height(Window *window, uint8_t height);





/*
 *--------------------------------------------------------------------------------------
 *     function:  int8_t app_window_timer_subscribe
 *    parameter:  window ָ
 *		  millis ʱûص룩
 *		  timer_callback ص 
 *       return:
 *  description:  
 * 	  other:
 *--------------------------------------------------------------------------------------
*/
int8_t app_window_timer_subscribe(Window *window,  uint32_t millis, AppServiceTimerCallback timer_callback, void *context);


#endif
